// Jason Brillante "Damdoshi"
// Hanged Bunny Studio 2014-2015
//
// Sewer Glue

#ifndef				__HBS_SEWER_GLUE_INTRO_HPP__
# define			__HBS_SEWER_GLUE_INTRO_HPP__
# include			<SFML/Audio.hpp>
# include			"Module.hpp"
# include			"SewerGlue.hpp"

namespace			hbs
{
  class				Intro : public hbs::Module
  {
  public:
    enum			Ressource
      {
	FIRST_RESSOURCE,
	BUNNY			= FIRST_RESSOURCE,
	FONT,
	LAST_RESSOURCE
      };

  protected:
    static const std::string	ressources_file[LAST_RESSOURCE];
    sf::Texture			ressources[LAST_RESSOURCE];
    sf::Sprite			sprites[LAST_RESSOURCE];

    int				step;
    int				bunny;

    bool			warping;
    hbs::SewerGlue::Klondike	destination;
    int				warp_animation;

    sf::Music			jingle;

  public:
    bool			Start(hbs::SewerGlue		&sg);
    void			Reset(void);
    bool			Event(const sf::Event		&event);
    bool			Play(uint64_t			delay);
    void			Display(sf::RenderTarget	&x);

    Intro(void);
    virtual ~Intro(void);
  };
}

#endif	//			__HBS_SEWER_GLUE_INTRO_HPP__
